commit 5e31048fd03f2e18e330cdf210221eeb3fa345d7
Author: Panagiotis Kanavos <pkanavos@gmail.com>
Date:   Tue Jan 3 21:30:08 2012 +0200

    Some warning fixes and change of some agents from a hand-coded Agent to Dataflow blocks

diff --git a/trunk/Pithos.Client.WPF/Pithos.Client.WPF.csproj b/trunk/Pithos.Client.WPF/Pithos.Client.WPF.csproj
index ceb5228..dafb034 100644
--- a/trunk/Pithos.Client.WPF/Pithos.Client.WPF.csproj
+++ b/trunk/Pithos.Client.WPF/Pithos.Client.WPF.csproj
@@ -291,7 +291,6 @@
     <Compile Include="NativeMethods.cs" />
     <Compile Include="Shell\Notification.cs" />
     <Compile Include="PithosAccount.cs" />
-    <Compile Include="PithosCommand.cs" />
     <Compile Include="Preferences\PreferencesView.xaml.cs">
       <DependentUpon>PreferencesView.xaml</DependentUpon>
     </Compile>
diff --git a/trunk/Pithos.Client.WPF/Preferences/AddAccountViewModel.cs b/trunk/Pithos.Client.WPF/Preferences/AddAccountViewModel.cs
index 4fbb448..174641c 100644
--- a/trunk/Pithos.Client.WPF/Preferences/AddAccountViewModel.cs
+++ b/trunk/Pithos.Client.WPF/Preferences/AddAccountViewModel.cs
@@ -281,7 +281,7 @@ namespace Pithos.Client.WPF.Preferences
                                });
             }
 */
-            catch (Exception ex)
+            catch
             {
                 HasValidCredentials = false;
                 MessageBox.Show("The account is not valid", "Account Error", MessageBoxButton.OK, MessageBoxImage.Stop);
diff --git a/trunk/Pithos.Core.Test/MockStatusKeeper.cs b/trunk/Pithos.Core.Test/MockStatusKeeper.cs
index 0d91029..07e807a 100644
--- a/trunk/Pithos.Core.Test/MockStatusKeeper.cs
+++ b/trunk/Pithos.Core.Test/MockStatusKeeper.cs
@@ -17,13 +17,13 @@ namespace Pithos.Core.Test
 
         private readonly string[] _states = { "Normal", "Modified", "Conflict", "Synch" };
 
-        ConcurrentDictionary<string, FileOverlayStatus> _overlayCache = new ConcurrentDictionary<string, FileOverlayStatus>();
-        ConcurrentDictionary<string, FileStatus> _statusCache = new ConcurrentDictionary<string, FileStatus>();
-        ConcurrentDictionary<string, string> _checksums = new ConcurrentDictionary<string, string>();
+        readonly ConcurrentDictionary<string, FileOverlayStatus> _overlayCache = new ConcurrentDictionary<string, FileOverlayStatus>();
+        readonly ConcurrentDictionary<string, FileStatus> _statusCache = new ConcurrentDictionary<string, FileStatus>();
+        readonly ConcurrentDictionary<string, string> _checksums = new ConcurrentDictionary<string, string>();
 
         public FileOverlayStatus GetFileOverlayStatus(string path)
         {
-            Contract.Requires(!String.IsNullOrWhiteSpace(path));
+            
             if (!_overlayCache.ContainsKey(path))
                 return FileOverlayStatus.Unversioned;
 
diff --git a/trunk/Pithos.Core/Agents/FileAgent.cs b/trunk/Pithos.Core/Agents/FileAgent.cs
index cfb5367..39eb56d 100644
--- a/trunk/Pithos.Core/Agents/FileAgent.cs
+++ b/trunk/Pithos.Core/Agents/FileAgent.cs
@@ -7,6 +7,7 @@ using System.IO;
 using System.Linq;
 using System.Text;
 using System.Threading.Tasks;
+using System.Threading.Tasks.Dataflow;
 using Pithos.Interfaces;
 using Pithos.Network;
 using log4net;
@@ -17,7 +18,8 @@ namespace Pithos.Core.Agents
     [Export]
     public class FileAgent
     {
-        Agent<WorkflowState> _agent;
+        //Agent<WorkflowState> _agent;
+        TransformBlock<WorkflowState, WorkflowState> _agent;
         private FileSystemWatcher _watcher;
 
         [Import]
@@ -33,94 +35,75 @@ namespace Pithos.Core.Agents
 
         private static readonly ILog Log = LogManager.GetLogger("FileAgent");
 
-        public void Start(AccountInfo accountInfo,string rootPath)
+        public FileAgent()
         {
-            if (accountInfo==null)
-                throw new ArgumentNullException("accountInfo");
-            if (String.IsNullOrWhiteSpace(rootPath))
-                throw new ArgumentNullException("rootPath");
-            if (!Path.IsPathRooted(rootPath))
-                throw new ArgumentException("rootPath must be an absolute path","rootPath");
-            Contract.EndContractBlock();
-
-            AccountInfo = accountInfo;
-            RootPath = rootPath;
-            _watcher = new FileSystemWatcher(rootPath);
-            _watcher.IncludeSubdirectories = true;            
-            _watcher.Changed += OnFileEvent;
-            _watcher.Created += OnFileEvent;
-            _watcher.Deleted += OnFileEvent;
-            _watcher.Renamed += OnRenameEvent;
-            _watcher.EnableRaisingEvents = true;
-
-
-            _agent = Agent<WorkflowState>.Start(inbox =>
-            {
-                Action loop = null;
-                loop = () =>
-                {
-                    var message = inbox.Receive();
-                    var process=message.Then(Process,inbox.CancellationToken);
-
-                    inbox.LoopAsync(process,loop,ex=>
-                        Log.ErrorFormat("[ERROR] File Event Processing:\r{0}", ex));
-                };
-                loop();
-            });
+            _agent = new TransformBlock<WorkflowState, WorkflowState>(async message => 
+                await TaskEx.Run(()=>Process(message)));
         }
 
-        private Task<object> Process(WorkflowState state)
+        private WorkflowState Process(WorkflowState message)
         {
-            if (state==null)
-                throw new ArgumentNullException("state");
-            Contract.EndContractBlock();
-
-            Debug.Assert(!Ignore(state.Path));
-
-            var networkState = NetworkGate.GetNetworkState(state.Path);
-            //Skip if the file is already being downloaded or uploaded and 
-            //the change is create or modify
-            if (networkState != NetworkOperation.None &&
-                (
-                    state.TriggeringChange == WatcherChangeTypes.Created ||
-                    state.TriggeringChange == WatcherChangeTypes.Changed
-                ))
-                return CompletedTask<object>.Default;
+            Debug.Assert(!Ignore(message.Path));
 
             try
             {
-                UpdateFileStatus(state);
-                UpdateOverlayStatus(state);
-                UpdateFileChecksum(state);
-                WorkflowAgent.Post(state);
+                //Skip if the file is already being downloaded or uploaded and 
+                //the change is create or modify
+                var networkState = NetworkGate.GetNetworkState(message.Path);
+                if (networkState != NetworkOperation.None &&
+                    (message.TriggeringChange == WatcherChangeTypes.Created ||
+                     message.TriggeringChange == WatcherChangeTypes.Changed))
+                    return null;
+
+                UpdateFileStatus(message);
+                UpdateOverlayStatus(message);
+                UpdateFileChecksum(message);
+                return message;
             }
             catch (IOException exc)
             {
-                if (File.Exists(state.Path))
+                if (File.Exists(message.Path))
                 {
-                    Log.WarnFormat("File access error occured, retrying {0}\n{1}", state.Path, exc);
-                    _agent.Post(state);
+                    Log.WarnFormat("File access error occured, retrying {0}\n{1}", message.Path, exc);
+                    _agent.Post(message);
                 }
                 else
                 {
-                    Log.WarnFormat("File {0} does not exist. Will be ignored\n{1}", state.Path, exc);
+                    Log.WarnFormat("File {0} does not exist. Will be ignored\n{1}", message.Path, exc);
                 }
             }
             catch (Exception exc)
             {
-                Log.WarnFormat("Error occured while indexing{0. The file will be skipped}\n{1}", state.Path, exc);
+                Log.WarnFormat("Error occured while indexing{0}. The file will be skipped}\n{1}",
+                               message.Path, exc);
             }
-            return CompletedTask<object>.Default;
-        }
 
+            return null;
+        }
 
-/*
-        private Task Process(Task<WorkflowState> action)
+        public void Start(AccountInfo accountInfo,string rootPath)
         {
-            return action.ContinueWith(t => Process(t.Result));
-        }
-*/
+            if (accountInfo==null)
+                throw new ArgumentNullException("accountInfo");
+            if (String.IsNullOrWhiteSpace(rootPath))
+                throw new ArgumentNullException("rootPath");
+            if (!Path.IsPathRooted(rootPath))
+                throw new ArgumentException("rootPath must be an absolute path","rootPath");
+            Contract.EndContractBlock();
+
+            _agent.LinkTo(WorkflowAgent.Agent);            
 
+            AccountInfo = accountInfo;
+            RootPath = rootPath;
+            _watcher = new FileSystemWatcher(rootPath);
+            _watcher.IncludeSubdirectories = true;            
+            _watcher.Changed += OnFileEvent;
+            _watcher.Created += OnFileEvent;
+            _watcher.Deleted += OnFileEvent;
+            _watcher.Renamed += OnRenameEvent;
+            _watcher.EnableRaisingEvents = true;
+           
+        }
 
         public bool Pause
         {
@@ -164,7 +147,7 @@ namespace Pithos.Core.Agents
             _watcher = null;
 
             if (_agent!=null)
-                _agent.Stop();
+                _agent.Complete();
         }
 
         // Enumerate all files in the Pithos directory except those in the Fragment folder
diff --git a/trunk/Pithos.Core/Agents/NetworkAgent.cs b/trunk/Pithos.Core/Agents/NetworkAgent.cs
index 40f84d6..6c1284e 100644
--- a/trunk/Pithos.Core/Agents/NetworkAgent.cs
+++ b/trunk/Pithos.Core/Agents/NetworkAgent.cs
@@ -21,6 +21,7 @@ namespace Pithos.Core.Agents
     {
         private Agent<CloudAction> _agent;
 
+
         [Import]
         public IStatusKeeper StatusKeeper { get; set; }
         
@@ -97,7 +98,7 @@ namespace Pithos.Core.Agents
                             await DownloadCloudFile(accountInfo,  cloudFile,downloadPath);
                             break;
                         case CloudActionType.DeleteCloud:
-                            DeleteCloudFile(accountInfo, cloudFile, cloudFile.Name);
+                            DeleteCloudFile(accountInfo, cloudFile);
                             break;
                         case CloudActionType.RenameCloud:
                             var moveAction = (CloudMoveAction)action;
@@ -249,7 +250,7 @@ namespace Pithos.Core.Agents
             _agent.Post(cloudAction);
         }
 
-        class ObjectInfoByNameComparer:IEqualityComparer<ObjectInfo>
+       /* class ObjectInfoByNameComparer:IEqualityComparer<ObjectInfo>
         {
             public bool Equals(ObjectInfo x, ObjectInfo y)
             {
@@ -260,7 +261,7 @@ namespace Pithos.Core.Agents
             {
                 return obj.Name.ToLower().GetHashCode();
             }
-        }
+        }*/
 
         
 
@@ -388,13 +389,13 @@ namespace Pithos.Core.Agents
                             Post(message);
                         }
 
-                        //Report the number of new files
-                        var remoteCount = distinctActions.Count(action=>
-                            action.Action==CloudActionType.DownloadUnconditional);
-/*
-                        if ( remoteCount > 0)
-                            StatusNotification.NotifyChange(String.Format("Processing {0} new files", remoteCount));
-*/
+                        /*                        //Report the number of new files
+                                                var remoteCount = distinctActions.Count(action=>
+                                                    action.Action==CloudActionType.DownloadUnconditional);
+
+                                                if ( remoteCount > 0)
+                                                    StatusNotification.NotifyChange(String.Format("Processing {0} new files", remoteCount));
+                        */
 
                         Log.Info("[LISTENER] End Processing");                        
                     }
@@ -519,17 +520,13 @@ namespace Pithos.Core.Agents
             NativeMethods.RaiseChangeNotification(newFilePath);
         }
 
-        private void DeleteCloudFile(AccountInfo accountInfo, ObjectInfo cloudFile,string fileName)
+        private void DeleteCloudFile(AccountInfo accountInfo, ObjectInfo cloudFile)
         {
             if (accountInfo == null)
                 throw new ArgumentNullException("accountInfo");
             if (cloudFile==null)
                 throw new ArgumentNullException("cloudFile");
 
-            if (String.IsNullOrWhiteSpace(fileName))
-                throw new ArgumentNullException("fileName");
-            if (Path.IsPathRooted(fileName))
-                throw new ArgumentException("The fileName should not be rooted","fileName");
             if (String.IsNullOrWhiteSpace(cloudFile.Container))
                 throw new ArgumentException("Invalid container", "cloudFile");
             Contract.EndContractBlock();
@@ -538,15 +535,17 @@ namespace Pithos.Core.Agents
 
             using ( log4net.ThreadContext.Stacks["DeleteCloudFile"].Push("Delete"))
             {
-                var info = fileAgent.GetFileInfo(fileName);
+                var fileName= cloudFile.RelativeUrlToFilePath(accountInfo.UserName);
+                var info = fileAgent.GetFileInfo(fileName);                
                 var fullPath = info.FullName.ToLower();
+
                 this.StatusKeeper.SetFileOverlayStatus(fullPath, FileOverlayStatus.Modified);
 
                 var account = cloudFile.Account ?? accountInfo.UserName;
                 var container = cloudFile.Container ;//?? FolderConstants.PithosContainer;
 
                 var client = new CloudFilesClient(accountInfo);
-                client.DeleteObject(account, container, fileName);
+                client.DeleteObject(account, container, cloudFile.Name);
 
                 this.StatusKeeper.ClearFileStatus(fullPath);
             }
diff --git a/trunk/Pithos.Core/Agents/StatusAgent.cs b/trunk/Pithos.Core/Agents/StatusAgent.cs
index 338f88e..1880df0 100644
--- a/trunk/Pithos.Core/Agents/StatusAgent.cs
+++ b/trunk/Pithos.Core/Agents/StatusAgent.cs
@@ -7,6 +7,7 @@ using System.IO;
 using System.Linq;
 using System.Threading;
 using System.Threading.Tasks;
+using System.Threading.Tasks.Dataflow;
 using Castle.ActiveRecord;
 using Castle.ActiveRecord.Framework.Config;
 using Pithos.Interfaces;
@@ -24,7 +25,8 @@ namespace Pithos.Core.Agents
         [System.ComponentModel.Composition.Import]
         public IPithosSettings Settings { get; set; }
 
-        private Agent<Action> _persistenceAgent;
+        //private Agent<Action> _persistenceAgent;
+        private ActionBlock<Action> _persistenceAgent;
 
 
         private static readonly ILog Log = LogManager.GetLogger("StatusAgent");
@@ -74,27 +76,16 @@ namespace Pithos.Core.Agents
 
         public void StartProcessing(CancellationToken token)
         {
-            _persistenceAgent = Agent<Action>.Start(queue =>
+            _persistenceAgent = new ActionBlock<Action>(async action=>
             {
-                Action loop = null;
-                loop = () =>
-                {
-                    var job = queue.Receive();
-                    job.ContinueWith(t =>
+                    try
+                    {
+                        await TaskEx.Run(action);
+                    }
+                    catch (Exception ex)
                     {
-                        var action = job.Result;
-                        try
-                        {
-                            action();
-                        }
-                        catch (Exception ex)
-                        {
-                            Log.ErrorFormat("[ERROR] STATE \n{0}",ex);
-                        }
-                        queue.DoAsync(loop);
-                    });
-                };
-                loop();
+                        Log.ErrorFormat("[ERROR] STATE \n{0}",ex);
+                    }
             });
             
         }
@@ -103,7 +94,7 @@ namespace Pithos.Core.Agents
 
         public void Stop()
         {
-            _persistenceAgent.Stop();            
+            _persistenceAgent.Complete();            
         }
        
 
diff --git a/trunk/Pithos.Core/Agents/WorkflowAgent.cs b/trunk/Pithos.Core/Agents/WorkflowAgent.cs
index 7b00a2f..ba0f3a6 100644
--- a/trunk/Pithos.Core/Agents/WorkflowAgent.cs
+++ b/trunk/Pithos.Core/Agents/WorkflowAgent.cs
@@ -7,6 +7,7 @@ using System.IO;
 using System.Linq;
 using System.Text;
 using System.Threading.Tasks;
+using System.Threading.Tasks.Dataflow;
 using Pithos.Interfaces;
 using Pithos.Network;
 using log4net;
@@ -16,7 +17,7 @@ namespace Pithos.Core.Agents
     [Export]
     public class WorkflowAgent
     {
-        Agent<WorkflowState> _agent;
+        private ActionBlock<WorkflowState> _agent;
                 
         public IStatusNotification StatusNotification { get; set; }
         [Import]
@@ -25,25 +26,44 @@ namespace Pithos.Core.Agents
         [Import]
         public NetworkAgent NetworkAgent { get; set; }
 
+        public ActionBlock<WorkflowState> Agent
+        {
+            get { return _agent; }
+        }
+
         private static readonly ILog Log = LogManager.GetLogger("WorkflowAgent");
 
         public void Start()
         {
-            _agent = Agent<WorkflowState>.Start(inbox =>
+            /*_agent = new ActionBlock<WorkflowState>(message =>
             {
                 Action loop = null;
                 loop = () =>
                 {
-                    var message = inbox.Receive();
+                    //var message = inbox.Receive();
+                    Process(message);
                     var process = message.Then(Process, inbox.CancellationToken);                        
                     inbox.LoopAsync(process,loop,ex=>
                             Log.ErrorFormat("[ERROR] Synch for {0}:\r{1}", message.Result.FileName, ex));
                 };
                 loop();
-            });
+            });*/
+            _agent = new ActionBlock<WorkflowState>(async message =>
+            {
+                try
+                {
+                    var action=await TaskEx.Run(()=>Process(message));
+                    if (action!=null)
+                        NetworkAgent.Post(action);
+                }
+                catch (Exception ex)
+                {
+                    Log.ErrorFormat("[ERROR] Synch for {0}:\r{1}", message.FileName, ex);                    
+                }
+            });            
         }
 
-        private Task<object> Process(WorkflowState state)
+        private CloudAction Process(WorkflowState state)
         {
             var accountInfo = state.AccountInfo;
             using (log4net.ThreadContext.Stacks["Workflow"].Push("Process"))
@@ -54,7 +74,7 @@ namespace Pithos.Core.Agents
                 {
                     if (Log.IsDebugEnabled) Log.DebugFormat("Skipping {0}",state.FileName);
                     
-                    return CompletedTask<object>.Default;
+                    return null;
                 }
                 string path = state.Path.ToLower();
 
@@ -66,7 +86,7 @@ namespace Pithos.Core.Agents
                     
                     if (Log.IsDebugEnabled) Log.DebugFormat("Skipped missing {0}", state.FileName);
 
-                    return CompletedTask<object>.Default;
+                    return null;
                 }
 
                 var fileState = FileState.FindByFilePath(path);
@@ -77,19 +97,16 @@ namespace Pithos.Core.Agents
                 {
                     case FileStatus.Created:
                     case FileStatus.Modified:
-                        NetworkAgent.Post(new CloudUploadAction(accountInfo,info, fileState, accountInfo.BlockSize,
-                            accountInfo.BlockHash));
-                        break;
+                        return new CloudUploadAction(accountInfo,info, fileState, accountInfo.BlockSize,
+                            accountInfo.BlockHash);
                     case FileStatus.Deleted:                       
-                        NetworkAgent.Post(new CloudDeleteAction(accountInfo,info, fileState));
-                        break;
+                        return new CloudDeleteAction(accountInfo,info, fileState);
                     case FileStatus.Renamed:
-                        NetworkAgent.Post(new CloudMoveAction(accountInfo,CloudActionType.RenameCloud, new FileInfo(state.OldPath),
-                                                              new FileInfo(state.Path)));
-                        break;
+                        return new CloudMoveAction(accountInfo,CloudActionType.RenameCloud, 
+                            new FileInfo(state.OldPath),
+                            new FileInfo(state.Path));
                 }
-
-                return CompletedTask<object>.Default;
+                return null;
             }
         }
 
@@ -146,7 +163,7 @@ namespace Pithos.Core.Agents
         {
             if (Log.IsDebugEnabled)
                 Log.DebugFormat("Posted {0} {1} {2}", workflowState.Path, workflowState.Status, workflowState.TriggeringChange);
-            _agent.Post(workflowState);
+            Agent.Post(workflowState);
         }
     }
 }
diff --git a/trunk/Pithos.Core/Pithos.Core.csproj b/trunk/Pithos.Core/Pithos.Core.csproj
index b5d9b04..7520ed1 100644
--- a/trunk/Pithos.Core/Pithos.Core.csproj
+++ b/trunk/Pithos.Core/Pithos.Core.csproj
@@ -339,6 +339,9 @@
     <Reference Include="System.ComponentModel.Composition" />
     <Reference Include="System.Core" />
     <Reference Include="System.ServiceModel" />
+    <Reference Include="System.Threading.Tasks.Dataflow">
+      <HintPath>..\Libraries\System.Threading.Tasks.Dataflow.dll</HintPath>
+    </Reference>
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
     <Reference Include="Microsoft.CSharp" />
diff --git a/trunk/Pithos.Interfaces/FileInfoExtensions.cs b/trunk/Pithos.Interfaces/FileInfoExtensions.cs
index 06a6721..fc6679e 100644
--- a/trunk/Pithos.Interfaces/FileInfoExtensions.cs
+++ b/trunk/Pithos.Interfaces/FileInfoExtensions.cs
@@ -17,14 +17,14 @@ namespace Pithos.Interfaces
             if (String.IsNullOrWhiteSpace(path))
                 throw new ArgumentNullException("path");            
             Contract.EndContractBlock();
-            
+            Contract.Assume(Enum.IsDefined(typeof(StringComparison),StringComparison.InvariantCultureIgnoreCase));
 
             if (!path.EndsWith("\\"))
                 path=path.ToLower() + "\\";
             int pathLength = path.Length;            
             
             var filePath = fileInfo.FullName;
-
+            
             if (!filePath.StartsWith(path,StringComparison.InvariantCultureIgnoreCase))
                 throw new ArgumentException(String.Format("The path {0} doesn't contain the file {1}",path,filePath));
             
diff --git a/trunk/Pithos.Interfaces/ObjectInfo.cs b/trunk/Pithos.Interfaces/ObjectInfo.cs
index 2fe41b5..67b60a0 100644
--- a/trunk/Pithos.Interfaces/ObjectInfo.cs
+++ b/trunk/Pithos.Interfaces/ObjectInfo.cs
@@ -114,6 +114,14 @@ namespace Pithos.Interfaces
 
         public ObjectInfo(string accountPath,string accountName,FileInfo fileInfo)
         {
+            if (String.IsNullOrWhiteSpace(accountPath))
+                throw new ArgumentNullException("accountPath");
+            if (string.IsNullOrWhiteSpace(accountName))
+                throw new ArgumentNullException("accountName");
+            if (fileInfo == null)
+                throw new ArgumentNullException("fileInfo");
+            Contract.EndContractBlock();
+
             var relativeUrl = fileInfo.AsRelativeUrlTo(accountPath);
             //The first part of the URL is the container
             var slashIndex = relativeUrl.IndexOf('/');
diff --git a/trunk/Pithos.Interfaces/PithosDateTimeConverter.cs b/trunk/Pithos.Interfaces/PithosDateTimeConverter.cs
index 451fb7d..8b62b82 100644
--- a/trunk/Pithos.Interfaces/PithosDateTimeConverter.cs
+++ b/trunk/Pithos.Interfaces/PithosDateTimeConverter.cs
@@ -25,18 +25,16 @@ namespace Pithos.Interfaces
 
             if (value is DateTime)
             {
-                DateTime dateTime = (DateTime)value;
-                DateTime utcDateTime = dateTime.ToUniversalTime();
+                var dateTime = (DateTime)value;
+                var utcDateTime = dateTime.ToUniversalTime();
                 seconds = (utcDateTime - _epoch).TotalSeconds; ;
             }
-#if !PocketPC && !NET20
             else if (value is DateTimeOffset)
             {
-                DateTimeOffset dateTimeOffset = (DateTimeOffset)value;
-                DateTimeOffset utcDateTimeOffset = dateTimeOffset.ToUniversalTime();
+                var dateTimeOffset = (DateTimeOffset)value;
+                var utcDateTimeOffset = dateTimeOffset.ToUniversalTime();
                 seconds= (utcDateTimeOffset.UtcDateTime - _epoch).TotalSeconds;
             }
-#endif
             else
             {
                 throw new Exception("Expected date object value.");
@@ -72,11 +70,8 @@ namespace Pithos.Interfaces
             DateTime d =  _epoch.AddSeconds(seconds);
 
 
-#if !PocketPC && !NET20
             if (t == typeof(DateTimeOffset))
                 return new DateTimeOffset(d);
-#endif
-
             return d;
         }
 
